<template>
    <div class="panel panel-default invoice">
        <div class="panel-body">
            <div class="invoice-form">
                <invoice-header :seller="seller" v-model="metadata" :invoice-title="invoiceTitle"/>

                <div class="body">
                    <div class="table-responsive">
                        <table class="table table-bordered table-condensed">
                            <thead>
                            <tr>
                                <th rowspan="2" width="5%">S.No.</th>
                                <th rowspan="2" width="40%">Details</th>
                                <th rowspan="2" width="15%">Quantity</th>
                                <th width="15%">Per Unit</th>
                                <th width="20%">Total</th>
                                <th width="5%" rowspan="2">
                                    <span class="btn btn-block btn-primary btn-xs" @click="addRow"><i class="fa fa-plus"></i></span>
                                </th>
                            </tr>
                            <tr>
                                <th>Amount (Rs.)</th>
                                <th>Amount (Rs.)</th>
                            </tr>
                            </thead>

                            <tbody>
                            <invoice-detail v-for="(detail, index) in details"
                                            :key="index"
                                            :value="detail"
                                            :index="index"
                                            @delete="removeRow(index)"/>
                            </tbody>

                            <tfoot>
                            <tr>
                                <td colspan="4" class="text-right pr10">
                                    <span>Discount</span>
                                    <input type="text" v-model="discount.percentage" @keypress="numberOnly" @keyup="discountUpdate('percent')" class="field discount-percent right">
                                    <span>%</span>
                                </td>
                                <td>
                                    <input type="text" class="field right" @keypress="numberOnly" @keyup="discountUpdate('amount')" v-model="discount.amount">
                                </td>
                                <td></td>
                            </tr>
                            <tr v-if="type !== 'income-tax'">
                                <td colspan="4" class="text-right pr10">Taxable Amount</td>
                                <td class="text-right" v-text="taxable_amount.toLocaleString(undefined, { minimumFractionDigits: 2 })"></td>
                                <td></td>
                            </tr>
                            <tr v-if="type === 'tax-invoice'">
                                <td colspan="4" class="text-right pr10">VAT 13 %</td>
                                <td class="text-right" v-text="vat.toLocaleString(undefined, { minimumFractionDigits: 2 })"></td>
                                <td></td>
                            </tr>
                            <tr>
                                <td colspan="4" class="text-right pr10"><strong>Total</strong></td>
                                <td class="text-right">
                                    <strong v-text="total.toLocaleString(undefined, { minimumFractionDigits: 2 })"></strong>
                                </td>
                                <td></td>
                            </tr>
                            </tfoot>
                        </table>
                    </div>
                </div>

                <div class="footer">
                    <div class="row">
                        <div class="col-sm-12">
                            <span>( In Words: </span>
                            <strong v-text="totalInWords"></strong>
                            <span> )</span>
                        </div>
                    </div>
                </div>
            </div>
        </div>

        <div class="panel-footer">
            <div class="row">
                <div class="col-sm-12">
                    <input type="button" class="btn btn-success pull-right" @click.prevent="saveInvoice" value="Save"/>
                </div>
            </div>
        </div>
    </div>
</template>

<script type="text/ecmascript-6">
    import InvoiceHeader  from "./InvoiceHeader";
    import InvoiceDetail  from "./InvoiceDetail";
    import {numberToWord} from "./../../helpers/helper";
    import axios          from "axios";

    export default {
        name: "InvoiceForm",

        components: {
            "invoice-header": InvoiceHeader,
            "invoice-detail": InvoiceDetail,
        },

        props: {
            type: {required: true, type: String},
            seller: {required: true, type: Object},
            invoiceSaveApi: {required: true, type: String},
        },

        data() {
            return {
                details: [
                    {
                        sn: 0,
                        particular: "",
                        quantity: 0.0,
                        rate: 0.0,
                        total: 0.0,
                    }],
                discount: {
                    percentage: 0.0,
                    amount: 0.0,
                },
                metadata: {},
            };
        },

        watch: {},

        computed: {
            invoiceTitle: function() {
                const typeMapping = {
                    "tax-invoice": "Tax Invoice",
                    "tax-abbr": "Abbreviated Tax Invoice",
                    "income-tax": "Invoice (Income Tax)",
                };

                return typeMapping[this.type] || "";
            },

            amount: function() {
                let sum = 0.0;

                this.details.map(detail => {
                    sum += detail.total;
                });

                return sum;
            },

            taxable_amount: function() {
                return this.amount - this.discount.amount;
            },

            vat: function() {
                return this.taxable_amount * (this.type === "tax-invoice" ? 0.13 : 0);
            },

            total: function() {
                return this.taxable_amount + this.vat;
            },

            totalInWords: function() {
                return numberToWord(this.total);
            },

            invoiceData: function() {
                return {
                    type: this.type,
                    purchaser: this.metadata.purchaser,
                    trans_date: this.metadata.trans_date,
                    issued_date: this.metadata.issued_date,
                    payment_method: this.metadata.payment_method,
                    details: this.details,
                    amount: this.amount,
                    discount: this.discount,
                    taxable_amount: this.taxable_amount,
                    vat: this.vat,
                    total: this.total,
                    total_in_words: this.totalInWords,
                };
            },
        },

        methods: {
            addRow() {
                this.details.push({
                    particular: "",
                    quantity: 0,
                    rate: 0,
                    total: 0,
                });
            },

            removeRow(index) {
                this.details.splice(index, 1);
            },

            discountUpdate(type) {
                if (!this.amount) {
                    return;
                }

                if (type === "percent") {
                    this.discount.amount = Number((Number(this.amount) * Number(this.discount.percentage) / 100).toFixed(2));
                } else if (type === "amount") {
                    this.discount.percentage = Number((Number(this.discount.amount) / Number(this.amount) * 100).toFixed(2));
                }
            },

            saveInvoice() {
                axios.post(this.invoiceSaveApi, this.invoiceData).then(response => {
                    if (response.data.success) {
                        window.location.href = response.data.data.redirect_url;
                    }
                }).catch(error => {
                    console.error(error);
                });
            },
        },
    };
</script>

<style scoped>

</style>
